<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey H.M. Taylor}
 * @copyright Onpub (TM). Copyright 2010, Onpub Co..
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 */
class OnpubDeleteArticles
{
  private $pdo;
  private $IDs;

  function __construct(PDO $pdo, $IDs)
  {
    $this->pdo = $pdo;
    $this->IDs = $IDs;
  }

  public function display()
  {
    $oarticles = new OnpubArticles($this->pdo);
    $articles = array ();

    try {
      if (is_array($this->IDs)) {
        $queryOptions = new OnpubQueryOptions();
        $queryOptions->includeContent = false;

        for ($i = 0; $i < sizeof($this->IDs); $i++) {
          $articles[] = $oarticles->get($this->IDs[$i], $queryOptions);
        }
      }
    }
    catch (PDOException $e) {
      throw $e;
    }

    $widget = new OnpubWidgetHeader("Delete Articles");
    $widget->display();

    en ('<form action="index.php" method="post">');
    en ('<div>');

    if (sizeof($articles)) {
      en ('<strong>Selected</strong>');
      en('<ul>');

      for ($i = 0; $i < sizeof($articles); $i++) {
        en ('<li><a href="index.php?onpub=EditArticle&amp;articleID=' . $articles[$i]->ID . '" title="Edit">' . $articles[$i]->title . '</a></li>');
        en ('<input type="hidden" name="articleIDs[]" value="' . $articles[$i]->ID . '">');
      }

      en('</ul>');

      en ('<input type="submit" value="Delete" id="confirmDelete">');
    }
    else {
      en ('<span class="onpub-error">No articles were selected to delete.</span>');
    }

    en ('<input type="hidden" name="onpub" value="DeleteArticleProcess">');

    en ('</div>');
    en ('</form>');

    $widget = new OnpubWidgetFooter();
    $widget->display();
  }

  public function validate() { }

  public function process()
  {
    $oarticles = new OnpubArticles($this->pdo);

    try {
      for ($i = 0; $i < sizeof($this->IDs); $i++) {
        $oarticles->delete($this->IDs[$i]);
      }
    }
    catch (PDOException $e) {
      throw $e;
    }
  }
}
?>